
class Time
  def to_ms
    (self.to_f * 1000.0).to_i
  end
end

class ExecutionLog
  attr_accessor :executionId, :startDate, :endDate, :host

  def initialize
    @host = Socket.gethostname
    @startDate = Time.now.to_ms
  end

  def self.from_json data
    executionLog = ExecutionLog.new
    executionLog.executionId = data['execution_id']
    executionLog.startDate = data['start_date']
    executionLog.endDate = data['end_date']
    executionLog.host = data['host']
    executionLog
  end

  def to_json(options={})
    {'execution_id' => @executionId, 'start_date' => @startDate, 'end_date' => @endDate, 'host' => @host}.to_json
  end
end