class FeatureLog
  attr_accessor :featureId, :result, :startDate, :endDate, :executionId, :scenarioLogs, :versionId,
                :totalScenariosNumber, :currentScenariosNumber, :resultSet

  def initialize
    @currentScenariosNumber = 0
    @scenarioLogs = []
    @resultSet = []
  end

  def to_json(options={})
    {'feature_id' => @featureId, 'result' => @result, 'start_date' => @startDate, 'end_date' => @endDate, 'execution_id' => @executionId,
     'scenario_logs' => @scenarioLogs, 'versionId' => @versionId}.to_json
  end

  def addScenarioResult result
    @resultSet.push result
    @currentScenariosNumber += 1
  end

  def addScenarioLog scenarioLog
    @scenarioLogs.push scenarioLog
  end

  def done?
    @currentScenariosNumber.eql? totalScenariosNumber
  end

end